import java.awt.*;
import java.net.*;
import java.util.*;
import java.applet.*;
import java.applet.AudioClip;

/*

// Create the Statistics Window
class StatsWindow extends Applet implements Runnable
{
    AudioClip music = null;

    public void run (String title)
    {
        music = getAudioClip(new URL(getDocumentBase(), title));
    }
}
*/


public class DotGame extends Applet implements Runnable
{
    String joe;

    // Main thread
    Thread loopThread;
    Thread loadThread;

    // Reserve images
  Image dot;
    Image redBarHorz;
    Image redBarVert;
    Image blueBarHorz;
    Image blueBarVert;
    Image BackGround;

    // Create off screen image
    Image offImage;
    Graphics offScreen;
    Graphics currentScreen;

    // Set the font
    Font font = new Font("Helvetica", Font.BOLD, 12);
    FontMetrics fm;
    int fontWidth;
    int fontHeight;
    Frame Warning;

    // Create the layout
    FlowLayout lm = new FlowLayout(FlowLayout.LEFT);

    // Create the Level box and Who goes first box
    Choice cLevel = new Choice();
    Choice cWturn = new Choice();
    Choice cMusic = new Choice();

    // Create STATS button and frame
    //Frame SWindow;
    //Button bStats = new Button("  Stats  ");

    boolean loaded = false;
    boolean easyPlay = true;
    boolean bWarning = true;

    // Reserve sounds
    AudioClip beep;
    AudioClip drip;
    AudioClip gong;
    AudioClip laugh;
    AudioClip music = null;

  // Initialize Vectors
  Vector vBrowse	= new Vector();
    Vector vDrawBar	= new Vector();
    Vector vGrid	= new Vector();
    Vector vCBrowse = new Vector();

    int i, j, dotXpos, dotYpos, browseBar, browseBefore, hScore, cScore;
    static int MAXLINES = 60;
    boolean cTurn = false, turnAgain = false, oh;
    boolean playing;
    long test, test2, test3, test4, test5, test6;
    int backup, leftoff, CNT, BOX = 0, alert = 0, loop = 0, amt, totcnt;
    int iTrack = 0;

    int[] storage = new int[100];
    int storeBar = -1;

    public void init()
    {
        Graphics g;
        Dimension d;

        // Find the size of the screen
        g = getGraphics();
        d = size();
        fm = g.getFontMetrics();
        fontWidth = fm.getMaxAdvance();
        fontHeight = fm.getHeight();

        // Set the layout of the applet
        setLayout(lm);

        // Add the levels of play
        cLevel.addItem ("Expert");
        cLevel.addItem ("Beginner");
        add(cLevel);
        cLevel.disable();

        // Add player/computer turns
        cWturn.addItem ("Player moves first");
        cWturn.addItem ("Computer moves first");
        add(cWturn);
        cWturn.disable();

        // Add STATS button
        cMusic.addItem("Music OFF");
        cMusic.addItem("Track 1");
        cMusic.addItem("Track 2");
        cMusic.addItem("Track 3");
        cMusic.addItem("Track 4");
        cMusic.addItem("Track 5");
        add(cMusic);
        cMusic.disable();

        // Create Stats Window info screen
        //SWindow = new StatsWindow ("DOT_TO_DOT Statistics");
        //SWindow.resize (300,200);

        // Used to display each move the computer makes
        currentScreen = g;

        // Create the off screen images
        offImage = createImage(size().width, size().height);
        offScreen = offImage.getGraphics();

        // Create the Browse Objects
        createBrowseObjects(vBrowse);

        // Create the grid
        createGrid();
    }

    public void loadSounds()
    {
        try
        {
            // Get the bitmaps
            dot					= getImage(new URL(getDocumentBase(), "images/Dot.gif"));
            redBarHorz	= getImage(new URL(getDocumentBase(), "images/RedBarHorz.gif"));
            redBarVert	= getImage(new URL(getDocumentBase(), "images/RedBarVert.gif"));
            blueBarHorz	= getImage(new URL(getDocumentBase(), "images/BlueBarHorz.gif"));
            blueBarVert	= getImage(new URL(getDocumentBase(), "images/BlueBarVert.gif"));

            // Deside what background to display
            switch (getRandom(0,6))
            {
                case 0: BackGround = getImage(new URL(getDocumentBase(), "images/DotImage1.jpg"));
                        break;

                case 1: BackGround = getImage(new URL(getDocumentBase(), "images/DotImage2.jpg"));
                        break;

                case 2: BackGround = getImage(new URL(getDocumentBase(), "images/DotImage3.jpg"));
                        break;

                case 3: BackGround = getImage(new URL(getDocumentBase(), "images/DotImage4.jpg"));
                        break;

                case 4: BackGround = getImage(new URL(getDocumentBase(), "images/DotImage5.jpg"));
                        break;

                case 5: BackGround = getImage(new URL(getDocumentBase(), "images/DotImage6.jpg"));
                        break;
            }

            // Get the sounds
            beep		= getAudioClip(new URL(getDocumentBase(), "sounds/Beep.au"));
            drip		= getAudioClip(new URL(getDocumentBase(), "sounds/Drip.au"));
            gong		= getAudioClip(new URL(getDocumentBase(), "sounds/Gong.au"));
            laugh		= getAudioClip(new URL(getDocumentBase(), "sounds/Laugh.au"));
            //music		= getAudioClip(new URL(getDocumentBase(), "sounds/Music5.au"));

            // Enable list boxes
            cWturn.enable();
            cLevel.enable();
            cMusic.enable();
        }
        catch (MalformedURLException e)
        {}
    }

    public void start()
    {
        if (loopThread == null)
        {
            loopThread = new Thread(this);
            loopThread.start();
        }
        if (!loaded && loadThread == null)
        {
            loadThread = new Thread(this);
            loadThread.start();
        }
    }

    public void stop()
    {
        if (loopThread != null)
        {
            loopThread.stop();
            loopThread = null;
            music.stop();
        }
        if (loadThread != null)
        {
            loadThread.stop();
            loadThread = null;
        }
    }

    public void run()
    {
        long startTime;

        // Lower this thread's priority and get the current time.
        Thread.currentThread().setPriority(Thread.MIN_PRIORITY);
        startTime = System.currentTimeMillis();

        // Run thread for loading sounds.
        if (!loaded && Thread.currentThread() == loadThread)
        {
            loadSounds();
            loaded = true;
            loadThread.stop();
        }

        // Main loop
        while (Thread.currentThread() == loopThread)
        {
            repaint();
            try
            {
                startTime += 50;
                Thread.sleep(Math.max(0, startTime - System.currentTimeMillis()));
            }
            catch (InterruptedException e)
            {
                break;
            }
        }
    }

    public void pause(int time)
    {
        try
        {
            Thread.sleep(time);
        }
        catch (InterruptedException e) { }
    }

    public int findLessScore ()
    {
        MouseBrowse p;
        int bar, backup, box = 0, cnt = 0, scr = 0, currentBar, counter = 0;
        storeBar = -1;

        loop = 0;
        amt = 999;
        totcnt = 0;

        alert = 1;
        repaint();

        // Initialize storage array
        for (j=0; j<storage.length; j++)
        {
            storage[j] = -1;
        }

        for (i=0; i<vBrowse.size(); i++)
        {
            bar = forceMove(i);
            if (bar == -1)
            {
                oh = true;
                repaint();
                break;
            }

            p = (MouseBrowse)vBrowse.elementAt(bar);
            if (p.lockBar == -1)
            {
                totcnt++;

                p.lockBar = bar;
                storage[cnt++] = bar;
                currentBar = bar;

                while (true)
                {
                    bar = generateWinMove();
                    if (bar != -1)
                    {
                        storage[cnt++] = bar;
                        p = (MouseBrowse)vBrowse.elementAt(bar);
                        p.lockBar = bar;
                        box++;
                    }
                    else
                    {
                        break;
                    }
                }

                // Restore info
                for (j=0; j<storage.length; j++)
                {
                    if (storage[j] != -1)
                    {
                        bar = storage[j];
                        p = (MouseBrowse)vBrowse.elementAt(bar);
                        p.lockBar = -1;
                        storage[j] = -1;
                    }
                }
                // Keep track of lowest score
                if (box < amt)
                {
                    amt = box;
                    storeBar = currentBar;
                }
                BOX = box;
                CNT = cnt;
                loop = i;
                box = 0;
                cnt = 0;
            }
        }

        // Finally return the BAR!!
        alert = 2;
        repaint();
        return storeBar;
    }

    // Computer makes a move
    public void computersTurn()
    {
        MouseBrowse p, p1, p2, p3, cb;
        int bar = -1, backupBar, reps = 0;
        leftoff = 0;

        if (!easyPlay)
        {
            while (true)
            {
                bar = generateWinMove();
                if (bar == -1)
                {
                    while (bar == -1)
                    {
                        bar = generateMove();
                        if (++reps > 1000)
                        {
                            reps = 0;
                            leftoff = 0;

                            while (true)
                            {
                                bar = forceMove(leftoff++);

                                if (leftoff >= 1)
                                {
                                    // Whatever bar we pick the opponet scores
                                    // Find the bar that scores LESS!
                                    leftoff = 0;
                                    //while (true)
                                    //{
                                    //	bar = forceMove(leftoff++);
                                    //	p = (MouseBrowse)vBrowse.elementAt(bar);
                                    //	if (p.lockBar == -1)
                                    //		break;
                                    //}
                                    bar = findLessScore ();
                                    repaint();
                                    break;
                                }
                                else
                                {

                                    p = (MouseBrowse)vBrowse.elementAt(bar);
                                    backup = p.lockBar;
                                    p.lockBar = bar;

                                    bar = generateWinMove();
                                    if (bar == -1)
                                    {
                                        bar = p.lockBar;
                                        p.lockBar = backup;
                                        break;
                                    }
                                    else
                                    {
                                        bar = p.lockBar;
                                        p.lockBar = backup;
                                    }
                                }
                            }
                        }
                    }
                    if (reps == 0)
                        break;

                    p = (MouseBrowse)vBrowse.elementAt(bar);
                    backup = p.lockBar;
                    p.lockBar = bar;

                    bar = generateWinMove();
                    if (bar == -1)
                    {
                        bar = p.lockBar;
                        p.lockBar = backup;
                        break;
                    }
                    else
                    {
                        bar = p.lockBar;
                        p.lockBar = backup;
                        //leftoff = 0;
                    }
                }
                else
                    break;
            }
        }

        while (true)
        {
            if (bar == -1)
            {
                Random r = new Random();
                bar = (int)(r.nextDouble()*60);
            }

            // JMH added (6/24/99)
            if (easyPlay)
            {
                while (true)
                {
                    // Check each bar that can play
                    p = (MouseBrowse)vBrowse.elementAt(bar);
                    if (p.lockBar == -1)
                        break;
                    bar = forceMove(bar);
                }
            }
            // JMH end

            // Check each bar that can play
            p = (MouseBrowse)vBrowse.elementAt(bar);
            if (p.lockBar == -1)
            {
                turnAgain = false;
                p.lockBar = bar;
                p.color = false;
                drip.play();
                vDrawBar.addElement(new Integer(bar));

                // Box completed?
                for (j=0; j<vGrid.size(); j++)
                {
                    Grid g = (Grid)vGrid.elementAt(j);
                    if (g.element == bar)
                    {
                        p1 = (MouseBrowse)vBrowse.elementAt(g.a);
                        p2 = (MouseBrowse)vBrowse.elementAt(g.b);
                        p3 = (MouseBrowse)vBrowse.elementAt(g.c);

                        if (p1.lockBar != -1 && p2.lockBar != -1 && p3.lockBar != -1)
                        {
                            turnAgain = true;
                            cScore++;
                            gong.play();
                        }
                    }
                }
                // Show the computers move and check for won game
                update(currentScreen);
                pause(300);
                if (checkWonGame())
                    return;

                if (!turnAgain)
                {
                    cTurn = false;
                    return;
                }
            }
            bar = generateWinMove();
            if (bar == -1)
            {
                computersTurn();
                return;
            }
        }
    }

    public int generateWinMove()
    {
        MouseBrowse p, p1, p2, p3;

        for (int i=0; i<vBrowse.size(); i++)
        {
            // Check each bar that can play
            p = (MouseBrowse)vBrowse.elementAt(i);
            if (p.lockBar == -1)
            {
                // Box completed?
                for (int j=0; j<vGrid.size(); j++)
                {
                    Grid g = (Grid)vGrid.elementAt(j);
                    if (g.element == i)
                    {
                        p1 = (MouseBrowse)vBrowse.elementAt(g.a);
                        p2 = (MouseBrowse)vBrowse.elementAt(g.b);
                        p3 = (MouseBrowse)vBrowse.elementAt(g.c);

                        // Found a winning move!
                        if (p1.lockBar != -1 && p2.lockBar != -1 && p3.lockBar != -1)
                        {
                            return i;
                        }
                    }
                }
            }
        }
        return -1;
    }

    public int generateMove()
    {
        MouseBrowse p, p1, p2, p3;
        int bar = 0, sum = 0;

        Random r = new Random();
        bar = (int)(r.nextDouble()*60);

        // Check each bar that can play
        p = (MouseBrowse)vBrowse.elementAt(bar);
        if (p.lockBar == -1)
        {
            // Box completed?
            for (j=0; j<vGrid.size(); j++)
            {
                Grid g = (Grid)vGrid.elementAt(j);
                if (g.element == bar)
                {
                    p1 = (MouseBrowse)vBrowse.elementAt(g.a);
                    p2 = (MouseBrowse)vBrowse.elementAt(g.b);
                    p3 = (MouseBrowse)vBrowse.elementAt(g.c);

                    test3 = g.element;
                    test4 = g.a;
                    test5 = g.b;
                    test6 = g.c;

                    // Possible move
                    if (p1.lockBar == -1 && p2.lockBar == -1 && p3.lockBar == -1)
                        return bar;
                }
            }
        }
        // Can't find any, give it up!
        test = 999;
        return -1;
    }

    public int forceMove(int start)
    {
        MouseBrowse p;
        int startAgain = start;

        for (int fi=start; fi<vBrowse.size(); fi++)
        {
            // Check each bar that can play
            p = (MouseBrowse)vBrowse.elementAt(fi);
            if (p.lockBar == -1)
                return fi;
        }

        // Second go around
        for (int fi=startAgain; fi>-1; fi--)
        {
            // Check each bar that can play
            p = (MouseBrowse)vBrowse.elementAt(fi);
            if (p.lockBar == -1)
                return fi;
        }

        return -1;
    }

    // Detect if user is browsing a bar
    public void browseBar(int x, int y)
    {
        int x1, y1, x2, y2;

        for (i=0; i<vBrowse.size(); i++)
        {
            MouseBrowse p = (MouseBrowse)vBrowse.elementAt(i);
            if (p.CheckBrowse (x,y))
            {
                browseBar = i;
                repaint();
                break;
            }
            else
            {
                if (browseBar != -1)
                {
                    browseBar = -1;
                    repaint();
                }
            }
        }
        dotXpos = x;
        dotYpos = y;
    }

    // User clicked on a bar...Display it!
    public void addBar(int x, int y)
    {
        MouseBrowse p, p1, p2, p3;

        for (i=0; i<vBrowse.size(); i++)
        {
            p = (MouseBrowse)vBrowse.elementAt(i);
            if (p.CheckBrowse (x,y))
            {
                // Make sure the BAR is not already in play
                if (p.lockBar == -1)
                {
                    turnAgain = false;
                    p.lockBar = i;
                    p.color = true;
                    drip.play();
                    vDrawBar.addElement(new Integer(i));

                    // Box completed?
                    for (j=0; j<vGrid.size(); j++)
                    {
                        Grid g = (Grid)vGrid.elementAt(j);
                        if (g.element == i)
                        {
                            p1 = (MouseBrowse)vBrowse.elementAt(g.a);
                            p2 = (MouseBrowse)vBrowse.elementAt(g.b);
                            p3 = (MouseBrowse)vBrowse.elementAt(g.c);

                            if (p1.lockBar != -1 && p2.lockBar != -1 && p3.lockBar != -1)
                            {
                                turnAgain = true;
                                hScore++;
                                gong.play();
                                if (checkWonGame())
                                    return;
                            }
                        }
                    }
                    // Computers turn
                    if (!turnAgain)
                    {
                        cTurn = true;
                        computersTurn();
                        return;
                    }
                }
                else
                {
                    // Bar is already in play - Honk at the user
                    beep.play();
                }
            }
        }
    }

    public boolean checkWonGame()
    {
        if ((hScore+cScore)==25)
        {
            playing = false;

            // Enable level and turn base list boxes
            cWturn.setEnabled(true);
            cLevel.setEnabled(true);
            //bStats.setEnabled(true);

            String szPlayer;
            String szCScore, szHScore;
            if (cScore > hScore)
            {
                laugh.play();
                szPlayer = "?player=Computer";
            }
            else
            {
                szPlayer = "?player=Human";
            }

            // Prepare scores
            szCScore = "CScore="+cScore;
            szHScore = "HScore="+hScore;

            // Update Stats
            try
            {
                AppletContext context = getAppletContext();
                context.showDocument(new URL("http://webappstogo.centurionx.com/Dot-to-Dot/DotGameResults.php"+szPlayer+"&"+szCScore+"&"+szHScore), "DotGame Results");
            }
            catch (MalformedURLException e){}

            return true;
        }
        else
            return false;
    }

    // Handle all actions
    public boolean action (Event evt, Object arg)
    {
        if (evt.target instanceof Choice)
        {
            String lable = (String)arg;
            if (lable.equals("Music OFF"))
            {
                if (music != null)
                {
                    iTrack = 0;
                    bWarning = true;
                    music.stop();
                    music = null;
                }
                return true;
            }
/*
            if (bWarning)
            {
                // Create warning dialog
                //AboutDialog ad;
                //Warning = new Frame();
                //ad = new AboutDialog(Warning, "Dot-to-Dot", true);
                //ad.resize(330, 134);
                //ad.setLocation(400, 200);
                //int x = ad.getBounds().width;
                //int y = ad.getBounds().height;
                //ad.setLocation(x, y);
                //ad.show();

                // User click cancel button
                if (!ad.bReturn)
                {
                    iTrack = 0;
                    cMusic.select(0);
                    music.stop();
                    return false;
                }

                // Did user check ignore checkbox?
                if (ad.Question.getState())
                    bWarning = false;
            }
*/
            if (lable.equals("Track 1"))
            {
                if (iTrack != 1)
                {
                    iTrack = 1;
                    try
                    {
                        if (music != null)
                            music.stop();
                        music = getAudioClip(new URL(getDocumentBase(), "sounds/Music1.au"));
                        music.loop();
                    }
                    catch (MalformedURLException e)
                    {}
                }
            }
            else if (lable.equals("Track 2"))
            {
                if (iTrack != 2)
                {
                    iTrack = 2;
                    try
                    {
                        if (music != null)
                            music.stop();
                        music = getAudioClip(new URL(getDocumentBase(), "sounds/Music2.au"));
                        music.loop();
                    }
                    catch (MalformedURLException e)
                    {}
                }
            }
            else if (lable.equals("Track 3"))
            {
                if (iTrack != 3)
                {
                    iTrack = 3;
                    try
                    {
                        if (music != null)
                            music.stop();
                        music = getAudioClip(new URL(getDocumentBase(), "sounds/Music3.au"));
                        music.loop();
                    }
                    catch (MalformedURLException e)
                    {}
                }
            }
            else if (lable.equals("Track 4"))
            {
                if (iTrack != 4)
                {
                    iTrack = 4;
                    try
                    {
                        if (music != null)
                            music.stop();
                        music = getAudioClip(new URL(getDocumentBase(), "sounds/Music4.au"));
                        music.loop();
                    }
                    catch (MalformedURLException e)
                    {}
                }
            }
            else if (lable.equals("Track 5"))
            {
                if (iTrack != 5)
                {
                    iTrack = 5;
                    try
                    {
                        if (music != null)
                            music.stop();
                        music = getAudioClip(new URL(getDocumentBase(), "sounds/Music5.au"));
                        music.loop();
                    }
                    catch (MalformedURLException e)
                    {}
                }
            }
            return true;
        }
        return false;
    }

    public boolean mouseMove(Event evt, int x, int y)
    {
        if (cTurn || !playing)
            return true;

        browseBar (x,y);
        return true;
    }

    public boolean mouseDown(Event evt, int x, int y)
    {
        if (cTurn || !playing)
            return true;

        addBar (x,y);
        return true;
    }

    public boolean keyDown(Event e, int key)
    {
        if (key == 112)
        {
            Mydatabase myDB = new Mydatabase();
            //if (null == myDB.queryDB("SELECT * from OnlinePoll"))
            if (myDB.connection == null)
            {
                beep.play();
            }
            else
            {
                gong.play();
            }
        }

        if (key == 112 && !playing)
        {
            playing		= true;
            cTurn		= false;
            turnAgain	= false;
            hScore		= 0;
            cScore		= 0;
            alert		= 0;

            if (vBrowse.size() > 0)
            {
                vBrowse.removeAllElements();
                vDrawBar.removeAllElements();
                vGrid.removeAllElements();

                createBrowseObjects(vBrowse);
                createGrid();
            }

            // Disable level/turn list boxes
            cWturn.setEnabled(false);
            cLevel.setEnabled(false);
            //bStats.setEnabled(false);

            // Set the level of the game
            if (cLevel.getSelectedIndex() == 0)
                easyPlay = false;
            else
                easyPlay = true;

            // Who goes first?
            if (cWturn.getSelectedIndex() == 0)
                cTurn = false;
            else
            {
                cTurn = true;
                computersTurn();
            }
        }
        return true;
    }

/*
    // Handle all actions
    public boolean action (Event evt, Object arg)
    {
        if (evt.target instanceof Button)
        {
            String lable = (String)arg;
            if (lable.equals("  Stats  "))
            {
                //if (!SWindow.isShowing())
                    //ShowStats();

            }
            return true;
        }

        return false;
    }


*/

    // Applet information.
    public String getAppletInfo()
    {
        return("DOT_TO_DOT, Copyright 2001 WebAppstogo");
    }

    public void paint(Graphics g)
    {
        update(g);
    }

    public void update (Graphics g)
    {
        boolean blink = true;
        String s,t;
        Dimension d = size();
        offScreen.setFont(font);

        offScreen.setColor(getBackground());
        offScreen.fillRect(0,0,size().width,size().height);
        offScreen.setColor(Color.black);

        // Get the mouse coordinates
        //offScreen.drawString ("joe= " + joe, 10, 40);
        //offScreen.drawString ("b1 = " + test3 + " b2 = " + test4 + " b3 = " + test5 + " b4 = " + test6 + " leftoff = " + leftoff, 10, 25);
        //offScreen.drawString ("ALERT = " + alert + " amt = " + amt + " box = " + BOX + " loop = " + loop + " easyPlay = " + easyPlay, 10,40);

        if (!loaded)
        {
            s = "Loading images and sounds...";
            offScreen.drawString(s, 75,150);
        }
        else
        {
            // Draw background
            offScreen.drawImage (BackGround, 0, 0, this);

            // Draw the current browsed bar
            if (playing)
                drawBars(offScreen, true, browseBar);

            // Draw the Dots
            for (j=50; j<260; j+=40)
            {
                for (i=10; i<240; i+=40)
                {
                    offScreen.drawImage(dot, i, j, this);
                }
            }

            // Draw all BARS that are in play
            if (playing)
            {
                MouseBrowse p;
                for (i=0; i<vDrawBar.size(); i++)
                {
                    Integer c = (Integer)vDrawBar.elementAt(i);
                    p = (MouseBrowse)vBrowse.elementAt(c.intValue());
                    drawBars(offScreen, p.color, c.intValue());
                }
            }

            // Show score
            offScreen.setColor (Color.black);
            offScreen.drawString("Human: " + hScore, 239, 60);
            offScreen.drawString("Computer: " + cScore, 239, 262);

            // Show Title/Game Over
            s = "Copyright 2001 WebAppstogo";
            offScreen.drawString(s, 11, 287);

            if (!playing)
            {
                offScreen.setColor (Color.red);
                s = "GAME OVER";
                t = "P - PLAY";
                offScreen.drawString(s, 238, 160);
                offScreen.drawString(t, 247, 170);

                // Show some effects - fun stuff
                drawBars(offScreen, true, getRandom(0,5));
                drawBars(offScreen, false, getRandom(5,10));
                drawBars(offScreen, true, getRandom(10,15));
                drawBars(offScreen, false, getRandom(15,20));
                drawBars(offScreen, true, getRandom(20,25));
                drawBars(offScreen, false, getRandom(25,30));
                drawBars(offScreen, true, getRandom(30,35));
                drawBars(offScreen, false, getRandom(35,40));
                drawBars(offScreen, true, getRandom(40,45));
                drawBars(offScreen, false, getRandom(45,50));
                drawBars(offScreen, false, getRandom(50,55));
                drawBars(offScreen, false, getRandom(55,60));
            }
        }

        // Show it
        g.drawImage(offImage, 0, 0, this);
    }

    public int getRandom(int min, int max)
    {
        Random r = new Random();
        min += (int)(r.nextDouble()*max);
        return min;
    }

    public void destroy()
    {
        offScreen.dispose();
    }

    public void createGrid()
    {
        // Grids based left to right
        // Box 1
        vGrid.addElement(new Grid(0,6,11,5));
        vGrid.addElement(new Grid(6,11,5,0));
        vGrid.addElement(new Grid(11,5,0,6));
        vGrid.addElement(new Grid(5,0,6,11));

        // Box 2
        vGrid.addElement(new Grid(1,7,12,6));
        vGrid.addElement(new Grid(7,12,6,1));
        vGrid.addElement(new Grid(12,6,1,7));
        vGrid.addElement(new Grid(6,1,7,12));

        // Box 3
        vGrid.addElement(new Grid(2,8,13,7));
        vGrid.addElement(new Grid(8,13,7,2));
        vGrid.addElement(new Grid(13,7,2,8));
        vGrid.addElement(new Grid(7,2,8,13));

        // Box 4
        vGrid.addElement(new Grid(3,9,14,8));
        vGrid.addElement(new Grid(9,14,8,3));
        vGrid.addElement(new Grid(14,8,3,9));
        vGrid.addElement(new Grid(8,3,9,14));

        // Box 5
        vGrid.addElement(new Grid(4,10,15,9));
        vGrid.addElement(new Grid(10,15,9,4));
        vGrid.addElement(new Grid(15,9,4,10));
        vGrid.addElement(new Grid(9,4,10,15));

        // Box 6
        vGrid.addElement(new Grid(11,17,22,16));
        vGrid.addElement(new Grid(17,22,16,11));
        vGrid.addElement(new Grid(22,16,11,17));
        vGrid.addElement(new Grid(16,11,17,22));

        // Box 7
        vGrid.addElement(new Grid(12,18,23,17));
        vGrid.addElement(new Grid(18,23,17,12));
        vGrid.addElement(new Grid(23,17,12,18));
        vGrid.addElement(new Grid(17,12,18,23));

        // Box 8
        vGrid.addElement(new Grid(13,19,24,18));
        vGrid.addElement(new Grid(19,24,18,13));
        vGrid.addElement(new Grid(24,18,13,19));
        vGrid.addElement(new Grid(18,13,19,24));

        // Box 9
        vGrid.addElement(new Grid(14,20,25,19));
        vGrid.addElement(new Grid(20,25,19,14));
        vGrid.addElement(new Grid(25,19,14,20));
        vGrid.addElement(new Grid(19,14,20,25));

        // Box 10
        vGrid.addElement(new Grid(15,21,26,20));
        vGrid.addElement(new Grid(21,26,20,15));
        vGrid.addElement(new Grid(26,20,15,21));
        vGrid.addElement(new Grid(20,15,21,26));

        // Box 11
        vGrid.addElement(new Grid(22,28,33,27));
        vGrid.addElement(new Grid(28,33,27,22));
        vGrid.addElement(new Grid(33,27,22,28));
        vGrid.addElement(new Grid(27,22,28,33));

        // Box 12
        vGrid.addElement(new Grid(23,29,34,28));
        vGrid.addElement(new Grid(29,34,28,23));
        vGrid.addElement(new Grid(34,28,23,29));
        vGrid.addElement(new Grid(28,23,29,34));

        // Box 13
        vGrid.addElement(new Grid(24,30,35,29));
        vGrid.addElement(new Grid(30,35,29,24));
        vGrid.addElement(new Grid(35,29,24,30));
        vGrid.addElement(new Grid(29,24,30,35));

        // Box 14
        vGrid.addElement(new Grid(25,31,36,30));
        vGrid.addElement(new Grid(31,36,30,25));
        vGrid.addElement(new Grid(36,30,25,31));
        vGrid.addElement(new Grid(30,25,31,36));

        // Box 15
        vGrid.addElement(new Grid(26,32,37,31));
        vGrid.addElement(new Grid(32,37,31,26));
        vGrid.addElement(new Grid(37,31,26,32));
        vGrid.addElement(new Grid(31,26,32,37));

        // Box 16
        vGrid.addElement(new Grid(33,39,44,38));
        vGrid.addElement(new Grid(39,44,38,33));
        vGrid.addElement(new Grid(44,38,33,39));
        vGrid.addElement(new Grid(38,33,39,44));

        // Box 17
        vGrid.addElement(new Grid(34,40,45,39));
        vGrid.addElement(new Grid(40,45,39,34));
        vGrid.addElement(new Grid(45,39,34,40));
        vGrid.addElement(new Grid(39,34,40,45));

        // Box 18
        vGrid.addElement(new Grid(35,41,46,40));
        vGrid.addElement(new Grid(41,46,40,35));
        vGrid.addElement(new Grid(46,40,35,41));
        vGrid.addElement(new Grid(40,35,41,46));

        // Box 19
        vGrid.addElement(new Grid(36,42,47,41));
        vGrid.addElement(new Grid(42,47,41,36));
        vGrid.addElement(new Grid(47,41,36,42));
        vGrid.addElement(new Grid(41,36,42,47));

        // Box 20
        vGrid.addElement(new Grid(37,43,48,42));
        vGrid.addElement(new Grid(43,48,42,37));
        vGrid.addElement(new Grid(48,42,37,43));
        vGrid.addElement(new Grid(42,37,43,48));

        // Box 21
        vGrid.addElement(new Grid(44,50,55,49));
        vGrid.addElement(new Grid(50,55,49,44));
        vGrid.addElement(new Grid(55,49,44,50));
        vGrid.addElement(new Grid(49,44,50,55));

        // Box 22
        vGrid.addElement(new Grid(45,51,56,50));
        vGrid.addElement(new Grid(51,56,50,45));
        vGrid.addElement(new Grid(56,50,45,51));
        vGrid.addElement(new Grid(50,45,51,56));

        // Box 23
        vGrid.addElement(new Grid(46,52,57,51));
        vGrid.addElement(new Grid(52,57,51,46));
        vGrid.addElement(new Grid(57,51,46,52));
        vGrid.addElement(new Grid(51,46,52,57));

        // Box 24
        vGrid.addElement(new Grid(47,53,58,52));
        vGrid.addElement(new Grid(53,58,52,47));
        vGrid.addElement(new Grid(58,52,47,53));
        vGrid.addElement(new Grid(52,47,53,58));

        // Box 25
        vGrid.addElement(new Grid(48,54,59,53));
        vGrid.addElement(new Grid(54,59,53,48));
        vGrid.addElement(new Grid(59,53,48,54));
        vGrid.addElement(new Grid(53,48,54,59));
    }

    public void createBrowseObjects(Vector v)
    {
        // Create Browse Rects for the 1st row
        v.addElement(new MouseBrowse(23,50,49,61));
        v.addElement(new MouseBrowse(61,50,87,61));
        v.addElement(new MouseBrowse(101,50,127,61));
        v.addElement(new MouseBrowse(142,50,169,61));
        v.addElement(new MouseBrowse(182,50,211,61));

        // Create Browse Rects for the 1st column
        v.addElement(new MouseBrowse(13,61,22,95));
        v.addElement(new MouseBrowse(53,61,62,95));
        v.addElement(new MouseBrowse(93,61,103,95));
        v.addElement(new MouseBrowse(132,61,143,95));
        v.addElement(new MouseBrowse(171,61,183,95));
        v.addElement(new MouseBrowse(212,61,223,95));

        // Create Browse Rects for the 2nd row
        v.addElement(new MouseBrowse(23,91,49,102));
        v.addElement(new MouseBrowse(61,91,87,102));
        v.addElement(new MouseBrowse(101,91,127,102));
        v.addElement(new MouseBrowse(142,91,169,102));
        v.addElement(new MouseBrowse(182,91,211,102));

        // Create Browse Rects for the 2nd column
        v.addElement(new MouseBrowse(13,99,22,134));
        v.addElement(new MouseBrowse(53,99,62,134));
        v.addElement(new MouseBrowse(93,99,103,134));
        v.addElement(new MouseBrowse(132,99,143,134));
        v.addElement(new MouseBrowse(171,99,183,134));
        v.addElement(new MouseBrowse(212,99,223,134));

        // Create Browse Rects for the 3rd row
        v.addElement(new MouseBrowse(23,132,49,142));
        v.addElement(new MouseBrowse(61,132,87,142));
        v.addElement(new MouseBrowse(101,132,127,142));
        v.addElement(new MouseBrowse(142,132,169,142));
        v.addElement(new MouseBrowse(182,132,211,142));

        // Create Browse Rects for the 3rd column
        v.addElement(new MouseBrowse(13,138,22,174));
        v.addElement(new MouseBrowse(53,138,62,174));
        v.addElement(new MouseBrowse(93,138,103,174));
        v.addElement(new MouseBrowse(132,138,143,174));
        v.addElement(new MouseBrowse(171,138,183,174));
        v.addElement(new MouseBrowse(212,138,223,174));

        // Create Browse Rects for the 4th row
        v.addElement(new MouseBrowse(23,172,49,182));
        v.addElement(new MouseBrowse(61,172,87,182));
        v.addElement(new MouseBrowse(101,172,127,182));
        v.addElement(new MouseBrowse(142,172,169,182));
        v.addElement(new MouseBrowse(182,172,211,182));

        // Create Browse Rects for the 4th column
        v.addElement(new MouseBrowse(13,178,22,214));
        v.addElement(new MouseBrowse(53,178,62,214));
        v.addElement(new MouseBrowse(93,178,103,214));
        v.addElement(new MouseBrowse(132,178,143,214));
        v.addElement(new MouseBrowse(171,178,183,214));
        v.addElement(new MouseBrowse(212,178,223,214));

        // Create Browse Rects for the 5th row
        v.addElement(new MouseBrowse(23,211,49,221));
        v.addElement(new MouseBrowse(61,211,87,221));
        v.addElement(new MouseBrowse(101,211,127,221));
        v.addElement(new MouseBrowse(142,211,169,221));
        v.addElement(new MouseBrowse(182,211,211,221));

        // Create Browse Rects for the 5th column
        v.addElement(new MouseBrowse(13,219,22,254));
        v.addElement(new MouseBrowse(53,219,62,254));
        v.addElement(new MouseBrowse(93,219,103,254));
        v.addElement(new MouseBrowse(132,219,143,254));
        v.addElement(new MouseBrowse(171,219,183,254));
        v.addElement(new MouseBrowse(212,219,223,254));

        // Create Browse Rects for the 6th row
        v.addElement(new MouseBrowse(23,251,49,262));
        v.addElement(new MouseBrowse(61,251,87,262));
        v.addElement(new MouseBrowse(101,251,127,262));
        v.addElement(new MouseBrowse(142,251,169,262));
        v.addElement(new MouseBrowse(182,251,211,262));
    }

    public void drawBars (Graphics screen, boolean color, int bar)
    {
        Image image1;
        Image image2;

        if (color)
        {
            image1 = redBarHorz;
            image2 = redBarVert;
        }
        else
        {
            image1 = blueBarHorz;
            image2 = blueBarVert;
        }

        switch (bar)
        {
            case 0:		screen.drawImage(image1, 22, 52, this);
                        break;
            case 1:		screen.drawImage(image1, 62, 52, this);
                        break;
            case 2:		screen.drawImage(image1, 103, 52, this);
                        break;
            case 3:		screen.drawImage(image1, 142, 52, this);
                        break;
            case 4:		screen.drawImage(image1, 183, 52, this);
                        break;

            case 5:		screen.drawImage(image2, 13, 60, this);
                        break;
            case 6:		screen.drawImage(image2, 53, 60, this);
                        break;
            case 7:		screen.drawImage(image2, 93, 60, this);
                        break;
            case 8:		screen.drawImage(image2, 133, 60, this);
                        break;
            case 9:		screen.drawImage(image2, 173, 60, this);
                        break;
            case 10:	screen.drawImage(image2, 213, 60, this);
                        break;

            case 11:	screen.drawImage(image1, 22, 92, this);
                        break;
            case 12:	screen.drawImage(image1, 62, 92, this);
                        break;
            case 13:	screen.drawImage(image1, 103, 92, this);
                        break;
            case 14:	screen.drawImage(image1, 142, 92, this);
                        break;
            case 15:	screen.drawImage(image1, 183, 92, this);
                        break;

            case 16:	screen.drawImage(image2, 13, 99, this);
                        break;
            case 17:	screen.drawImage(image2, 53, 99, this);
                        break;
            case 18:	screen.drawImage(image2, 93, 99, this);
                        break;
            case 19:	screen.drawImage(image2, 133, 99, this);
                        break;
            case 20:	screen.drawImage(image2, 173, 99, this);
                        break;
            case 21:	screen.drawImage(image2, 213, 99, this);
                        break;

            case 22:	screen.drawImage(image1, 22, 132, this);
                        break;
            case 23:	screen.drawImage(image1, 62, 132, this);
                        break;
            case 24:	screen.drawImage(image1, 103, 132, this);
                        break;
            case 25:	screen.drawImage(image1, 142, 132, this);
                        break;
            case 26:	screen.drawImage(image1, 183, 132, this);
                        break;

            case 27:	screen.drawImage(image2, 13, 139, this);
                        break;
            case 28:	screen.drawImage(image2, 53, 139, this);
                        break;
            case 29:	screen.drawImage(image2, 93, 139, this);
                        break;
            case 30:	screen.drawImage(image2, 133, 139, this);
                        break;
            case 31:	screen.drawImage(image2, 173, 139, this);
                        break;
            case 32:	screen.drawImage(image2, 213, 139, this);
                        break;

            case 33:	screen.drawImage(image1, 22, 172, this);
                        break;
            case 34:	screen.drawImage(image1, 62, 172, this);
                        break;
            case 35:	screen.drawImage(image1, 103, 172, this);
                        break;
            case 36:	screen.drawImage(image1, 142, 172, this);
                        break;
            case 37:	screen.drawImage(image1, 183, 172, this);
                        break;

            case 38:	screen.drawImage(image2, 13, 179, this);
                        break;
            case 39:	screen.drawImage(image2, 53, 179, this);
                        break;
            case 40:	screen.drawImage(image2, 93, 179, this);
                        break;
            case 41:	screen.drawImage(image2, 133, 179, this);
                        break;
            case 42:	screen.drawImage(image2, 173, 179, this);
                        break;
            case 43:	screen.drawImage(image2, 213, 179, this);
                        break;

            case 44:	screen.drawImage(image1, 22, 212, this);
                        break;
            case 45:	screen.drawImage(image1, 62, 212, this);
                        break;
            case 46:	screen.drawImage(image1, 103, 212, this);
                        break;
            case 47:	screen.drawImage(image1, 142, 212, this);
                        break;
            case 48:	screen.drawImage(image1, 183, 212, this);
                        break;

            case 49:	screen.drawImage(image2, 13, 219, this);
                        break;
            case 50:	screen.drawImage(image2, 53, 219, this);
                        break;
            case 51:	screen.drawImage(image2, 93, 219, this);
                        break;
            case 52:	screen.drawImage(image2, 133, 219, this);
                        break;
            case 53:	screen.drawImage(image2, 173, 219, this);
                        break;
            case 54:	screen.drawImage(image2, 213, 219, this);
                        break;

            case 55:	screen.drawImage(image1, 22, 252, this);
                        break;
            case 56:	screen.drawImage(image1, 62, 252, this);
                        break;
            case 57:	screen.drawImage(image1, 103, 252, this);
                        break;
            case 58:	screen.drawImage(image1, 142, 252, this);
                        break;
            case 59:	screen.drawImage(image1, 183, 252, this);
                        break;
        }
    }
}
