import java.awt.Image;
import java.net.*;

// Image statistics class
public class ImageStats
{
    final int EXPAND 		= 1;
    final int SHRINK 		= 2;

    int xImagePos;
    int yImagePos;
    int xImageSize;
    int yImageSize;
    int xImageSizeOrg;
    int yImageSizeOrg;
    int xImagePosOrg;
    int yImagePosOrg;
    int State;
    Image Img;
    URL UrlLink;
    boolean bUrlLink;

    int xImg1, yImg1, xImg2, yImg2;

    ImageStats(Image Img, int x1, int y1, int x2, int y2, String sUrl)
    {
        this.Img = Img;
        this.xImagePos  = this.xImagePosOrg = x1;
        this.yImagePos  = this.yImagePosOrg = y1;
        this.xImageSize = this.xImageSizeOrg = x2;
        this.yImageSize = this.yImageSizeOrg = y2;
        this.State = SHRINK;

        // Assign images dimensions
        this.xImg1 = x1;
        this.yImg1 = y1;
        this.xImg2 = x1 + x2;
        this.yImg2 = y1 + y2;

        try
        {
            UrlLink = new URL (sUrl);
            bUrlLink = true;
        }
        catch (MalformedURLException e)
        {
            bUrlLink = false;
        }
    }

    boolean IsUrlAvailable()
    {
        return bUrlLink;
    }

    URL GetUrl()
    {
        return UrlLink;
    }

    boolean CheckBrowse(int mx, int my)
    {
        if (mx >= xImg1 && mx <= xImg2 && my >= yImg1 && my <= yImg2)
            return true;
        else
            return false;
    }
}
