import java.awt.*;
import java.net.*;
import java.util.*;
import java.applet.*;

/*
class MyCanvas extends java.awt.Canvas
{
    Image offImage;

    int x = size().width / 2;
    int y = size().height / 2;

    public void init()
    {
        offImage = createImage(size().width, size().height);
    }

    public void paint(Graphics g)
    {
        x++;y++;
        g.setColor(Color.black);url
        g.drawLine(x-10,y,x-2,y);
        g.drawLine(x+10,y,x+2,y);
        g.drawLine(x,y-10,x,y-2);
        g.drawLine(x,y+10,x,y+2);

        g.drawImage(offImage, 0, 0, this);
    }
}

class BaseFrame extends Frame
{
    Graphics offScreen;
    Graphics g;
    Dimension d;
    GridLayout gl;
    MyCanvas can;

    String message = "This is a window";
    Label l;

    BaseFrame(String title)
    {
        super(title);

        gl = new GridLayout(1,1);
        can = new MyCanvas();
        setLayout(new BorderLayout());
        add(can);

        //l = new Label(message, Label.CENTER);
        //l.setFont(new Font("Helvetica", Font.PLAIN, 12));
        //add("Center", l);
    }
}
*/

public class ImageViewer extends Applet implements Runnable
{
    String WebAppstogo;
    String Author;
    String Registered;
    String szStatusWindow;
    Font hfont;
    FontMetrics hfm;
    Color hColor;
    boolean bTrialVersion;
    boolean bloaded;
    boolean bStatusWindow;

    // Main thread
    Thread loopThread;
    Thread loadThread;

    // Create off screen image
    Image offImage;
    Graphics offScreen;
    //BaseFrame window;

    Vector vImageStats;

    final int EXPAND 		= 1;
    final int SHRINK 		= 2;

    final int CS_WAIT       = 1;

    boolean bDrawing = false;
    int iImage = 0;
    int iMode = SHRINK;
    int iSpeed = 0;
    int iImageSize = 0;
    int iTotalImages = 0;
    int iCurrentImageCnt = 0;
    boolean bSetHighlight = false;
    boolean bUrlActive = false;
    boolean bAuthor = false;
    Color BackgroundColor;

    Image j1;
    Image j2;
    Image j3;
    Image j4;

    public void init()
    {
        WebAppstogo = "WebAppstogo.com";
        Author = "ImageViewer - Copyright(c) 2001 WebAppstogo";
        Registered = "1LFJFGI5KDE"; // Cheesy, but works
        hfont = new Font("TimesRoman", Font.ITALIC, 15);
        hfm = getFontMetrics(hfont);
        bTrialVersion = true;
        bloaded = false;
        bStatusWindow = false;

        Graphics g;
        Dimension d;

        // Find the size of the screen
        g = getGraphics();
        d = getSize();

        // Create the off screen images
        offImage = createImage(getSize().width, getSize().height);
        offScreen = offImage.getGraphics();

        // Message Vector
        vImageStats = new Vector();
    }

    public void loadImages()
    {
        // read in image parameters
        String szImageName;
        String szImage;
        String szTemp;
        String szUrl;
        int iCnt  = 0;
        int iXcnt = 0;
        int iYcnt = 0;
        int iXpos = 0;
        int iYpos = 0;
        Image imgNew = null;
        Image imgOld = null;

        // Make sure Status param exists
        szStatusWindow = getParameter ("Status");
        if (szStatusWindow != null)
        {
            bStatusWindow = true;
        }

        // Registered Customer?
        String reg = getParameter ("Reg");
        if (reg != null)
        {
            if (reg.equalsIgnoreCase(Registered))
                bTrialVersion = false;
        }

        // Make sure author param exists
        szTemp = getParameter ("Author");
        if (szTemp == null)
        {
            return;
        }

        if (szTemp.equalsIgnoreCase(Author))
        {
            bAuthor = true;
        }
        else
        {
            // No author name, no dice
            return;
        }

        // Determine how many images to load
        while (true)
        {
            szImageName = "Image" + ++iCnt;
            szImage = getParameter (szImageName);
            if (szImage == null)
            {
                break;
            }
        }

        // Keep count of total images to process
        iTotalImages = iCnt;
        iCnt = 0;

        // Get Speed param
        szTemp = getParameter ("Speed");
        if (szTemp == null)
        {
            iImageSize = 15;
        }
        else
        {
            iSpeed = Integer.parseInt(szTemp);
            if (iSpeed > 50)
                iSpeed = 50;
            if (iSpeed < 1)
                iSpeed = 1;
        }

        // Get Image start size param
        szTemp = getParameter ("ImageSize");
        if (szTemp == null)
        {
            iImageSize = 4;
        }
        else
        {
            iImageSize = Integer.parseInt(szTemp);
            if (iImageSize > 100)
                iImageSize = 100;
            if (iImageSize < 1)
                iImageSize = 1;
        }

        // Back ground color
        szTemp = "background";
        String sBackGround = getParameter (szTemp);
        if (sBackGround == null)
        {
            BackgroundColor = Color.black;
        }
        else
        {
            BackgroundColor = getColor(getParameter(szTemp));
        }

        // Send Loading Images
        showStatus("Loading Images...");

        while (true)
        {
            // Increment counter for images/urls
            ++iCnt;

            // Parse URL's
            szTemp = "Url" + iCnt;
            szUrl = getParameter (szTemp);

            // Parse images files
            szImageName = "Image" + iCnt;
            szImage = getParameter (szImageName);
            iCurrentImageCnt = iCnt-1;
            if (szImage == null)
            {
                break;
            }
            else
            {
                try
                {
                    imgNew	= getImage(new URL(getDocumentBase(), szImage));
                }
                catch (MalformedURLException e)
                {
                    imgNew = null;
                }

                // Load image completely
                while (imgNew.getWidth(this) == -1) { pause(100); }

                if (imgOld != null)
                    vImageStats.addElement(new ImageStats(imgNew, iXpos, iYpos,
                                          imgOld.getWidth(this)/iImageSize, imgOld.getHeight(this)/iImageSize, szUrl));
                else
                    vImageStats.addElement(new ImageStats(imgNew, iXpos, iYpos,
                                          imgNew.getWidth(this)/iImageSize, imgNew.getHeight(this)/iImageSize, szUrl));

                imgOld  = imgNew;
                iXpos   = imgOld.getWidth(this)/iImageSize * ++iXcnt;

                if (iXpos+imgOld.getWidth(this)/iImageSize > getSize().width)
                {
                    iXpos   = 0;
                    iXcnt   = 0;
                    iYpos   = imgOld.getHeight(this)/iImageSize * ++iYcnt;
                }
            }
        }
        // Show credits in status bar
        if (bStatusWindow && !bTrialVersion)
            showStatus(szStatusWindow);
        else
            showStatus(Author);

        // Refresh screen
        repaint();
    }


    public void start()
    {
        if (!bloaded && loadThread == null)
        {
            loadThread = new Thread(this);
            loadThread.start();
        }

        if (loopThread == null)
        {
            loopThread = new Thread(this);
            loopThread.start();
        }
    }

    public void stop()
    {
        if (loopThread != null)
        {
            //loopThread.stop();
            loopThread = null;
            vImageStats.removeAllElements();
        }
        if (loadThread != null)
        {
            //loadThread.stop();
            loadThread = null;
        }
    }

    public void run()
    {
        long startTime;

        // Lower this thread's priority and get the current time.
        Thread.currentThread().setPriority(Thread.MIN_PRIORITY);
        startTime = System.currentTimeMillis();

        // Run thread for loading sounds.
        if (!bloaded && Thread.currentThread() == loadThread)
        {
            loadImages();
            bloaded = true;
            loadThread = null;
        }

        // Main loop
        while (Thread.currentThread() == loopThread)
        {
            if (bloaded)
            {
                DrawImage();
            }

            try
            {
                startTime += 10;
                Thread.sleep(Math.max(0, startTime - System.currentTimeMillis()));
            }
            catch (InterruptedException e)
            {
                break;
            }
        }
    }

    public void DrawImage()
    {
      // It all starts here!!
      if (!bUrlActive)
      {
        if (bDrawing)
        {
          bDrawing = false;
          startImage(iImage, iMode);
        }
      }

      // Refresh screen
      repaint();
    }

    Color getColor(String param)
    {
        int r, g, b;
        // use StringTokenizer to parse the paramter which is
        // in "R,G,B" form. Then return the new Color.
        StringTokenizer st = new StringTokenizer(param, ",");
        try
        {
            r = Integer.parseInt(st.nextToken());
            g = Integer.parseInt(st.nextToken());
            b = Integer.parseInt(st.nextToken());
            return new Color(r, g, b);
        }
        catch (Exception e)
        {
            return Color.black;
        }
    }

    public boolean mouseExit(Event evt, int x, int y)
    {
        // Reset highlight flag;
        bSetHighlight = false;

        return true;
    }

    public boolean mouseBrowse(int x1, int y1, int xpos, int ypos, String currentString, FontMetrics fm)
    {
        int x2 = xpos + fm.stringWidth(currentString);
        int y2 = ypos + (fm.getHeight()-20);

        if ((x1 >= xpos) && (y1 >= ypos - fm.getHeight()) && (x1 <= x2) && (y1 <= y2))
            return true;
        else
            return false;
    }

    public boolean mouseMove(Event evt, int x, int y)
    {
        int xPos = (getSize().width - hfm.stringWidth(WebAppstogo) - 5);
        int yPos = (getSize().height) - (hfm.getHeight() - 15);

        if (mouseBrowse(x, y, xPos, yPos, WebAppstogo, hfm))
            bSetHighlight = true;
        else
            bSetHighlight = false;
        return true;
    }

    public boolean mouseDown(Event evt, int x, int y)
    {
        if (!bloaded)
            return true;

        if (bUrlActive)
            return true;

        if (bSetHighlight && bTrialVersion)
        {
            try
            {
                AppletContext context = getAppletContext();
                context.showDocument(new URL("http://www.webappstogo.com"));
            }
            catch (MalformedURLException e){}
            bUrlActive = true;
            return true;
        }

        if (bDrawing)
            return true;

        for (int i=0; i<vImageStats.size(); i++)
        {
            ImageStats ImgStat = (ImageStats)vImageStats.elementAt(i);
            if (ImgStat.State == EXPAND)
            {
                if (ImgStat.IsUrlAvailable())
                {
                    //try
                    //{
                        AppletContext context = getAppletContext();
                        //context.showDocument(new URL("http://users.ev1.net/~jhillman/ImageViewer.htm"));
                        //URL url = ImgStat.GetUrl();
                        context.showDocument(ImgStat.GetUrl());
                    //}
                    //catch (MalformedURLException e){}
                    bUrlActive = true;
                    return true;
                }

                ImgStat.State = iMode = SHRINK;
                bDrawing = true;
                iImage = i;
                return true;
            }

            if (ImgStat.CheckBrowse(x,y))
            {
                bDrawing = true;
                iImage = i;
                ImgStat.State = iMode = EXPAND;
            }
        }
        return true;
    }

    public void startImage(int Element, int iMode)
    {
        switch (iMode)
        {
            case EXPAND:
                    scroll(Element,EXPAND,0,0);
                    break;

            case SHRINK:
                    scroll(Element,SHRINK,0,0);
                    break;
        }
    }

    public void scroll(int Pic, int start, int time, int pause)
    {
        ImageStats ImgStat = (ImageStats)vImageStats.elementAt(Pic);
        int iWidth = getSize().width;
        int iHeight = getSize().height;

        // Start Sequence
        switch (start)
        {
            case EXPAND:
                    while (ImgStat.xImageSize < iWidth || ImgStat.yImageSize < iHeight ||
                           ImgStat.xImagePos != 0 || ImgStat.yImagePos != 0)
                    {
                        if (ImgStat.xImagePos > 0)
                            ImgStat.xImagePos -= iSpeed*2;
                        else
                            ImgStat.xImagePos = 0;

                        if (ImgStat.yImagePos > 0)
                            ImgStat.yImagePos -= iSpeed*2;
                        else
                            ImgStat.yImagePos = 0;

                        if (ImgStat.xImageSize < iWidth)
                            ImgStat.xImageSize += iSpeed*2;
                        else
                            ImgStat.xImageSize = iWidth;

                        if (ImgStat.yImageSize < iHeight)
                            ImgStat.yImageSize += iSpeed*2;
                        else
                            ImgStat.yImageSize = iHeight;

                        repaint();
                        pause(5);
                    }

                    // Make sure everyone is in the right position
                    //ImgStat.xImagePos = 0;
                    //ImgStat.yImagePos = 0;
                    //ImgStat.xImageSize = iWidth;
                    //ImgStat.yImageSize = iHeight;
                    //repaint();
                    break;

            case SHRINK:
                    while (ImgStat.xImageSize > ImgStat.xImageSizeOrg || ImgStat.yImageSize > ImgStat.yImageSizeOrg ||
                           ImgStat.xImagePos != ImgStat.xImagePosOrg || ImgStat.yImagePos != ImgStat.yImagePosOrg)
                    {
                        if (ImgStat.xImagePos < ImgStat.xImagePosOrg)
                            ImgStat.xImagePos += iSpeed*2;
                        else
                            ImgStat.xImagePos = ImgStat.xImagePosOrg;

                        if (ImgStat.yImagePos < ImgStat.yImagePosOrg)
                            ImgStat.yImagePos += iSpeed*2;
                        else
                            ImgStat.yImagePos = ImgStat.yImagePosOrg;

                        if (ImgStat.xImageSize > ImgStat.xImageSizeOrg)
                            ImgStat.xImageSize -= iSpeed*2;
                        else
                            ImgStat.xImageSize = ImgStat.xImageSizeOrg;

                        if (ImgStat.yImageSize > ImgStat.yImageSizeOrg)
                            ImgStat.yImageSize -= iSpeed*2;
                        else
                            ImgStat.yImageSize = ImgStat.yImageSizeOrg;

                        repaint();
                        pause(5);
                    }

                    // Make sure everyone is in the right psoition
                    //ImgStat.xImagePos = ImgStat.xImagePosOrg;
                    //ImgStat.yImagePos = ImgStat.yImagePosOrg;
                    //ImgStat.xImageSize = ImgStat.xImageSizeOrg;
                    //ImgStat.yImageSize = ImgStat.yImageSizeOrg;
                    //repaint();
                    break;
        }
    }

    public void pause(int time)
    {
        try
        {
            loopThread.sleep(time);
        }
        catch (InterruptedException e) { }
    }

    public void paint(Graphics g)
    {
        update(g);
    }

    public void update (Graphics g)
    {
        offScreen.setColor(BackgroundColor);
        offScreen.fillRect(0,0,getSize().width,getSize().height);

        if (!bAuthor)
        {
            offScreen.setColor(Color.red);
            offScreen.drawString("Fill in author value with", 0, getSize().height/2);
            offScreen.drawString(Author, 0, getSize().height/2 + hfm.getHeight());
        }
        else
        {
           if (!bloaded)
            {
                offScreen.setColor(Color.white);
                offScreen.drawString("Loading image "+iCurrentImageCnt+" of "+(iTotalImages-1), getSize().width/3, getSize().height/2);
            }
            else
            {
                // Draw Image
                for (int j=0; j<vImageStats.size(); j++)
                {
                    ImageStats ImgStat = (ImageStats)vImageStats.elementAt(j);
                    offScreen.drawImage (ImgStat.Img, ImgStat.xImagePos, ImgStat.yImagePos,
                                        ImgStat.xImageSize, ImgStat.yImageSize, this);
                }

                ImageStats ImgStat = (ImageStats)vImageStats.elementAt(iImage);
                offScreen.drawImage (ImgStat.Img, ImgStat.xImagePos, ImgStat.yImagePos,
                                        ImgStat.xImageSize, ImgStat.yImageSize, this);

                if (bTrialVersion)
                {
                    // Draw Company name
                    if (bSetHighlight)
                    {
                        setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));
                        offScreen.setColor(Color.blue);
                    }
                    else
                    {
                        setCursor(Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR));
                        offScreen.setColor(Color.white);
                    }

                    int x = (getSize().width / 2 + 20);
                    int y = (getSize().height - 10);
                    int x1 = x;
                    int y1 = y;
                    int w = 60;
                    int h = 30;

                    offScreen.setColor(Color.white);

                    //for (int k=0; k<4; k++)
                    //{
                     //   offScreen.draw3DRect(x1++, y1++, w, h, true);
                     //   w -= 2;
                     //   h -= 2;
                    //}
                    //offScreen.fillRect(x, y, w+1, h+1);

                    offScreen.setFont(hfont);
                    offScreen.drawString (WebAppstogo, x, y);
                }
            }
        }
        // Show it
        g.drawImage(offImage, 0, 0, this);
        //window.can.offImage = offImage;
        //window.can.repaint();
  }
}



