import java.awt.*;
import java.net.*;
import java.util.*;
import java.applet.*;


class MenuItemRect extends Component
{
    int             iStartXpos;
    int             iStartYpos;
    int             iWidth;
    int             iHeight;
    int             iExpand;
    static int      siYpos = 0;
    static int      iOrigYpos = 0;
    static int      siStandardXposLength = 0;
    boolean         bRaised;
    static boolean  bFirstTime = true;

    MenuItemRect(Dimension d, FontMetrics fm, String menuItem, int iBorderSize)
    {
        int iWD = d.width; //fm.stringWidth(menuItem) + iBorderSize * 2 + 15;
        int iHT = fm.getHeight() + iBorderSize;

        // Track longest menu item
        if (iWD > siStandardXposLength)
            siStandardXposLength = iWD;

        // Adjust Y-axis correctly
        if (bFirstTime)
        {
            bFirstTime = false;
            siYpos = -iHT;
            iOrigYpos = siYpos;
        }

        this.siYpos     += iHT+1;
        this.iStartXpos  = 0;
        this.iStartYpos  = siYpos;
        this.iWidth      = iWD;
        this.iHeight     = iHT;
        this.bRaised     = true;
    }

    protected void SetRaised(boolean bStatus)
    {
        bRaised = bStatus;
    }

    protected boolean GetRaised()
    {
        return bRaised;
    }
}


class MenuItem extends MenuItemRect
{
    Color	    textColor;	    // Text color of message
    Color       origColor;      // Keeps track of original Text color
    String 	    menuItem;   	// Message to display
    String      szStatus;       // Status Message
    URL		    urlLink;
    Color	    urlColor;
    Color       cOrigBorderColor;
    Color       cBorderColor;
    Color       cBorderBrowseColor;
    int         iBorderSize;
    int         iSubItems;
    FontMetrics fm;
    boolean     bExpanded;
    boolean     bSetColor, bUrlLink, brolledOver;
    int         iState;

    MenuItem(Dimension d, String menuItem, Font fFont, FontMetrics fm, Color textColor, String sUrl, String szStatus, Color urlColor, int iBorderSize, Color cBorderColor, Color cBorderBrowseColor)
    {
        // Call abstract class MenuItemRect
        super(d, fm, menuItem, iBorderSize);

        this.textColor 	        = textColor;
        this.origColor          = textColor;
        this.menuItem 		    = menuItem;
        this.urlColor		    = urlColor;
        this.bSetColor		    = false;
        this.iBorderSize        = iBorderSize;
        this.cOrigBorderColor   = cBorderColor;
        this.cBorderColor       = cBorderColor;
        this.cBorderBrowseColor = cBorderBrowseColor;
        this.fm                 = fm;
        this.iSubItems          = 1;
        this.bExpanded          = false;
        this.iState             = 0;
        this.szStatus           = szStatus;

        try
        {
            urlLink = new URL (sUrl);
            bUrlLink = true;
        }
        catch (MalformedURLException e)
        {
            bUrlLink = false;
        }
    }

    public boolean mouseBrowse(int x1, int y1, int xpos, int ypos)
    {
        int x2 = xpos + siStandardXposLength;
        int y2 = ypos + iHeight;

        if ((x1 >= xpos) && (y1 >= ypos) && (x1 <= x2) && (y1 <= y2))
            return true;
        else
            return false;
    }

    public URL getUrl()
    {
        return urlLink;
    }
}

public class MenuNav extends Applet implements Runnable
{
    // Who is this guy?
    String Author = "MenuNav - Copyright(c) 2001 Joe Hillman";
    String Unregs = "Unregistered Applet - MenuNav - Copyright(c) 2001 WebAppstogo (http://www.webappstogo.com)";
    String Registered = "8JGH5FP3WNJ";
    Color hColor;
    Color cHiTextColor;
    Color cBhiColor;
    Color cTextColor;
    Color cBColor;
    boolean bAuthor = false;

    final int NOACTION  = 0;
    final int EXPAND    = 1;
    final int COLLAPSE  = 2;
    final int EXPANDED  = 3;

    // MenuItem Stuff
    Font fFont;
    int iCnt;
    int iBSize;
    int iMenuItems = 100;
    MenuItem MI[] = new MenuItem[iMenuItems];

    // MenuItem Vector
    Vector vMenu = new Vector();

    // Menu Text Vector
    Vector vMenuText = new Vector();

    // Url Vector
    Vector vURL	= new Vector();

    // Url Vector
    Vector vStatus = new Vector();

    // Main thread
    Thread loopThread;

    // Create off screen image
    Image offImage;
    Graphics offScreen;

    // Set the font
    Font font;
    FontMetrics fm;

    int xpos, ypos;
    String currentString;

    int   	parmMessages;
    Font  	parmFont;
    String	parmFontName;
    int		parmFontType;
    int   	parmFontSize;
    boolean bUrlActive = false;

    String  url$;
    boolean bRunApplet      = false;
    boolean bCheckURL       = false;
    boolean bTrialVersion   = true;

    Graphics g;
    Dimension d;

    public void init()
    {
        // Find the size of the screen
        g = getGraphics();
        d = size();

        // Create the off screen images
        offImage = createImage(size().width, size().height);
        offScreen = offImage.getGraphics();

        // Parse data

        // Get Font parameter
        // Create font
        String szfont = getParameter ("Font");
        fFont = getFont(szfont);
        fm = getFontMetrics(fFont);

        // Make sure author param exists
        String szTemp = getParameter ("Author");
        if (szTemp == null)
        {
            return;
        }

        if (szTemp.equalsIgnoreCase(Author))
        {
            bAuthor = true;
        }
        else
        {
            // No author name, no dice
            return;
        }

        // Registered Customer?
        String reg = getParameter ("Reg");
        if (reg != null)
        {
            if (reg.equalsIgnoreCase(Registered))
                bTrialVersion = false;
        }

        // Get background color parameter
        String szBackgroundColor = getParameter("BackGroundColor");
        if (szBackgroundColor == null)
        {
            // Assign default color
            cBColor = new Color(208, 208, 0);
        }
        else
        {
            // Set new background color
            cBColor = getColor(szBackgroundColor);
        }

        // Get highlight background color parameter
        String szHLBackgroundColor = getParameter("HLBackGroundColor");
        if (szHLBackgroundColor == null)
        {
            // Assign default color
            cBhiColor = new Color(208, 208, 0);
        }
        else
        {
            // Set new highlight background color
            cBhiColor = getColor(szHLBackgroundColor);
        }

        // Get Text color parameter
        String szTextColor = getParameter("TextColor");
        if (szTextColor == null)
        {
            // Assign default color
            cTextColor = new Color(208, 208, 0);
        }
        else
        {
            // Set new Text color
            cTextColor = getColor(szTextColor);
        }

        // Get highlight Text color parameter
        String szHLTextColor = getParameter("HLTextColor");
        if (szHLTextColor == null)
        {
            // Assign default color
            cHiTextColor = new Color(208, 208, 0);
        }
        else
        {
            // Set new highlight Text color
            cHiTextColor = getColor(szHLTextColor);
        }

        // Get highlight Text color parameter
        String szButton3d = getParameter("Button3d");
        try
        {
            iBSize = Integer.parseInt(szButton3d);
        }
        catch (Exception e)
        {
            iBSize = 2;
        }

        // Get MenuX parameters
        iCnt = 0;
        while (true)
        {
            String szMenuText = "Menu" + ++iCnt;
            String szMenu = getParameter (szMenuText);
            if (szMenu == null)
            {
                break;
            }
            else
            {
                // Add Menu Text to storage
                vMenuText.addElement(szMenu);
            }
        }

        // Get UrlX parameters
        iCnt = 0;
        while (true)
        {
            String szUrlText = "Url" + ++iCnt;
            String szUrl = getParameter (szUrlText);
            if (szUrl == null)
            {
                break;
            }
            else
            {
                // Add Menu Text to storage
                vURL.addElement(szUrl);
            }
        }

        // Get UrlX parameters
        iCnt = 0;
        while (true)
        {
            String szStatusWindow = "Status" + ++iCnt;
            String szStatus = getParameter (szStatusWindow);
            if (szStatus == null)
            {
                break;
            }
            else
            {
                // Add Menu Text to storage
                vStatus.addElement(szStatus);
            }
        }

        // Create our little Navaigator
        String szMenuText;
        String szUrl;
        String szStatus;
        for (int j=0; j<vMenuText.size(); j++)
        {
            szMenuText = (String)vMenuText.elementAt(j);

            try
            {
                szUrl = (String)vURL.elementAt(j);
            }
            catch (Exception e)
            { szUrl = ""; }

            try
            {
                szStatus = (String)vStatus.elementAt(j);
            }
            catch (Exception e)
            { szStatus = ""; }

            // Create menu item J
            MI[j] = new MenuItem(d,szMenuText, fFont, fm, cTextColor, szUrl, szStatus, cHiTextColor, iBSize, cBColor, cBhiColor);
        }

/*
        // Navigator should only run on my site, unless of course
        // someone has registered it:)
        if (bCheckURL)
        {
            // Make sure this applet is running on my web page
            URL url = getCodeBase();
            url$ = url.toString();
            String search = "~jhillman";

            for (int h=0; h<url$.length(); h++)
            {
                if (url$.regionMatches(true,h,search,0,search.length()))
                {
                    bRunApplet = true;
                    break;
                }
            }
        }
        else
        {
            bRunApplet = true;
        }
*/
    }

    // Parse Font parameters
    Font getFont(String param)
    {
        String fSize = null;
        String tType = null;

        if (param != null)
        {
            try
            {
                StringTokenizer sFont = new StringTokenizer(param, ",");
                parmFontName = sFont.nextToken();
                fSize = sFont.nextToken();
                tType = sFont.nextToken();
            }
            catch (Exception e)
            {
                parmFontSize = 12;
                parmFontType = Font.PLAIN;
                parmFontName = "TimesRoman";
                parmFont = new Font(parmFontName, parmFontType, parmFontSize);
                return parmFont;
            }
        }

        if (tType == null || fSize == null || parmFontName == null)
        {
            parmFontSize = 12;
            parmFontType = Font.PLAIN;
            parmFontName = "TimesRoman";
            parmFont = new Font(parmFontName, parmFontType, parmFontSize);
            return parmFont;
        }
        else
        {
            if (tType.equalsIgnoreCase("plain"))
                parmFontType = Font.PLAIN;
            else if (tType.equalsIgnoreCase("italic"))
                parmFontType = Font.ITALIC;
            else
                parmFontType = Font.BOLD;

            try { parmFontSize = Integer.parseInt(fSize); }
            catch (Exception e)
            {
                parmFontSize = 10;
            }
        }

        try
        {
            parmFont = new Font(parmFontName, parmFontType, parmFontSize);
        }
        catch (Exception e)
        {
            parmFontSize = 12;
            parmFontType = Font.PLAIN;
            parmFontName = "TimesRoman";
            parmFont = new Font(parmFontName, parmFontType, parmFontSize);
        }

        return parmFont;
    }

    Color getColor(String param)
    {
        int r, g, b;
        // use StringTokenizer to parse the paramter which is
        // in "R,G,B" form. Then return the new Color.
        StringTokenizer st = new StringTokenizer(param, ",");
        try
        {
            r = Integer.parseInt(st.nextToken());
            g = Integer.parseInt(st.nextToken());
            b = Integer.parseInt(st.nextToken());
            return new Color(r, g, b);
        }
        catch (Exception e)
        {
            return new Color(128,128,128);
        }
    }

    public void start()
    {
        for (int i=0; i<vMenuText.size(); i++)
        {
            MI[i].siYpos = MI[0].iOrigYpos;
        }

        if (loopThread == null)
        {
            loopThread = new Thread(this);
            loopThread.start();
        }
    }

    public void stop()
    {
        if (loopThread != null)
        {
            loopThread.stop();
            loopThread = null;

            // Delete vectors
            vMenu.removeAllElements();
            vMenuText.removeAllElements();
            vURL.removeAllElements();
            vStatus.removeAllElements();

            // Re-initialize static variables
            MI[0].siYpos = 0;
            MI[0].iOrigYpos = 0;
            MI[0].siStandardXposLength = 0;
            MI[0].bFirstTime = true;
        }
    }

    public void run()
    {
        long startTime;

        // Lower this thread's priority and get the current time.
        Thread.currentThread().setPriority(Thread.MIN_PRIORITY);
        startTime = System.currentTimeMillis();

        // Main loop
      while (Thread.currentThread() == loopThread)
        {
            BeginApp();
            try
            {
                startTime += 10;
                Thread.sleep(Math.max(0, startTime - System.currentTimeMillis()));
            }
            catch (InterruptedException e)
            {
                break;
            }
        }
    }

    public void BeginApp()
    {
        // Lets get it started
        repaint();
    }

    public boolean mouseMove(Event evt, int x, int y)
    {
        for (int i=0; i<vMenuText.size(); i++)
        {
            if (MI[i].mouseBrowse(x, y, MI[i].iStartXpos, MI[i].iStartYpos))
            {
                MI[i].textColor = MI[i].urlColor;
                MI[i].cBorderColor = MI[i].cBorderBrowseColor;

                // Display status if reg user
                if (!bTrialVersion)
                    setStatusText(MI[i].szStatus);
                else
                    showStatus(Unregs);
            }
            else
            {
                MI[i].textColor = MI[i].origColor;
                MI[i].cBorderColor = MI[i].cOrigBorderColor;
            }
        }
        return true;
    }

    public boolean mouseExit(Event evt, int x, int y)
    {
        for (int i=0; i<vMenuText.size(); i++)
        {
            MI[i].textColor = MI[i].origColor;
            MI[i].cBorderColor = MI[i].cOrigBorderColor;
        }
        return true;
    }

    public boolean mouseEnter(Event evt, int x, int y)
    {
        return true;
    }

    public boolean mouseUp(Event evt, int x, int y)
    {
        for (int i=0; i<vMenuText.size(); i++)
        {
            if (!MI[i].GetRaised())
            {
                MI[i].SetRaised(true);
                MI[i].iStartXpos += 2;
                MI[i].iStartYpos += 2;
                MI[i].iState = NOACTION;

            }
        }
        return true;
    }

    public boolean mouseDown(Event evt, int x, int y)
    {
        if (bUrlActive)
        return true;

        for (int i=0; i<vMenuText.size(); i++)
        {
            if (MI[i].iState != NOACTION)
                return true;
        }

        for (int i=0; i<vMenuText.size(); i++)
        {
            if (MI[i].mouseBrowse(x, y, MI[i].iStartXpos, MI[i].iStartYpos))
            {
                MI[i].SetRaised(false);
                MI[i].iStartXpos -= 2;
                MI[i].iStartYpos -= 2;

            for (int j=0; j<vMenuText.size(); j++)
            {
                MI[j].iState = NOACTION;
            }
                try
                {
                    AppletContext context = getAppletContext();
                    context.showDocument(MI[i].getUrl());
                }
                catch(Exception e)
                {}
                bUrlActive = true;
            }
        }
        return true;
    }

    public void setStatusText(String szStatus)
    {
        showStatus(szStatus);
    }

    public void destroy()
    {
        offScreen.dispose();
    }

    public void paint(Graphics g)
    {
        update(g);
    }

    public void update (Graphics g)
    {
        int x;
        int y;
        int w;
        int h;
        int xStr;
        int yStr;

        offScreen.setFont(fFont);
        offScreen.setColor(cBColor);
        offScreen.fillRect(0,0,size().width,size().height);

        if (!bAuthor)
        {
            offScreen.setColor(Color.red);
            offScreen.drawString("Fill in author value with", 0, size().height/2);
            offScreen.drawString(Author, 0, size().height/2 + fm.getHeight());
        }
        else
        {
            // Draw text string
            fm = offScreen.getFontMetrics(fFont);

            for (int i=0; i<vMenuText.size(); i++)
            {
                x = MI[i].iStartXpos;
                y = MI[i].iStartYpos;
                w = MI[i].siStandardXposLength;
                h = MI[i].iHeight;

                offScreen.setColor(MI[i].cBorderColor);

                for (int k=0; k<MI[i].iBorderSize; k++)
                {
                    offScreen.draw3DRect(x++, y++, w, h, MI[i].bRaised);
                    w -= 2;
                    h -= 2;
                }
                offScreen.fillRect(x, y, w+1, h+1);

                yStr = MI[i].iStartYpos+fm.getHeight()/2 + fFont.getSize()/2 - fm.getDescent() - fm.getLeading() + MI[i].iBorderSize;
                xStr = MI[i].iStartXpos + iBSize + 8;

                offScreen.setColor(MI[i].textColor);
                offScreen.drawString (MI[i].menuItem, xStr, yStr);
            }
        }

        // Show it
        g.drawImage(offImage, 0, 0, this);
    }
}